Index: tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java
===================================================================
--- tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java	(revision 2730)
+++ tmp/org.txm.edition.rcp/src/org/txm/edition/rcp/editors/EditionPanel.java	(revision 2731)
@@ -47,57 +47,92 @@
 	
 	
 	private ProgressListener progresslistener;
-	//	private List<String> wordids;
-	//	private List<String> lineids;
+	
+	// private List<String> wordids;
+	// private List<String> lineids;
 	/** The edition. */
 	Text currentText;
+	
 	Edition currentEdition;
+	
 	Page currentPage;
+	
 	protected SynopticEditionEditor synopticEditionEditor;
+	
 	private ISelectionProvider selProvider;
+	
 	private MenuManager menuManager;
 	
 	private HashSet<int[]> highlightedAreas = null;
 	
-	//HashMap<String, ArrayList<RGBA>> highlightedColorSpans = new HashMap<String, ArrayList<RGBA>>(); // background color
+	// HashMap<String, ArrayList<RGBA>> highlightedColorSpans = new HashMap<String, ArrayList<RGBA>>(); // background color
 	
-	HashMap<String, ArrayList<RGBA>> highlightedColorPerWordIDS = new HashMap<String, ArrayList<RGBA>>(); // background color
+	HashMap<String, ArrayList<RGBA>> highlightedColorPerWordIDS = new HashMap<>(); // background color
+	
 	public static final String STYLE_NORMAL = "normal"; //$NON-NLS-1$
+	
 	public static final String STYLE_ITALIC = "italic"; //$NON-NLS-1$
+	
 	public static final String STYLE_OBLIQUE = "oblique"; //$NON-NLS-1$
-	HashMap<String, String> fontStylePerWordIDS = new HashMap<String, String>();
+	
+	HashMap<String, String> fontStylePerWordIDS = new HashMap<>();
+	
 	public static final String WEIGHT_NORMAL = "normal"; //$NON-NLS-1$
+	
 	public static final String WEIGHT_BOLD = "bold"; //$NON-NLS-1$
-	HashMap<String, String> fontWeightPerWordIDS = new HashMap<String, String>();
-	HashMap<String, ArrayList<RGBA>> fontColorPerWordIDS = new HashMap<String, ArrayList<RGBA>>();
+	
+	HashMap<String, String> fontWeightPerWordIDS = new HashMap<>();
+	
+	HashMap<String, ArrayList<RGBA>> fontColorPerWordIDS = new HashMap<>();
+	
 	public static final String SIZE_SMALL = "small"; //$NON-NLS-1$
+	
 	public static final String SIZE_MEDIUM = "medium"; //$NON-NLS-1$
+	
 	public static final String SIZE_LARGE = "larger"; //$NON-NLS-1$
+	
 	public static final String SIZE_SMALLER = "smaller"; //$NON-NLS-1$
+	
 	public static final String SIZE_LARGER = "larger"; //$NON-NLS-1$
-	HashMap<String, String> fontSizePerWordIDS = new HashMap<String, String>();
+	
+	HashMap<String, String> fontSizePerWordIDS = new HashMap<>();
+	
 	public static final String FAMILLY_TIMES = "\"Times New Roman\", Times"; //$NON-NLS-1$
+	
 	public static final String FAMILLY_ARIAL = "Arial"; //$NON-NLS-1$
+	
 	public static final String FAMILLY_COURIER = "\"Courier New\", Courier"; //$NON-NLS-1$
-	HashMap<String, String> fontFamillyPerWordIDS = new HashMap<String, String>();
+	
+	HashMap<String, String> fontFamillyPerWordIDS = new HashMap<>();
+	
 	public static final String VARIANT_NORMAL = "normal"; //$NON-NLS-1$
+	
 	public static final String VARIANT_SMALLCAPS = "small-caps"; //$NON-NLS-1$
-	HashMap<String, String> fontVariantPerWordIDS = new HashMap<String, String>();
+	
+	HashMap<String, String> fontVariantPerWordIDS = new HashMap<>();
+	
 	String focusedWordID = null;
 	
-	public static final String highlightscript = "try { var elt = document.getElementById(\"%s\");" + //$NON-NLS-1$ //$NON-NLS-2$
+	public static final String highlightscript = "try { var elt = document.getElementById(\"%s\");" + //$NON-NLS-1$
 			"elt.style.backgroundColor=\"rgb(%s,%s,%s)\";" + //$NON-NLS-1$
-			//"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
-			//"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
-			//"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
-			//"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
+			// "elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
+			// "elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
+			// "elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
+			// "elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
 			"} catch (e) { };"; //$NON-NLS-1$
+			
 	public static final String highlightscriptRuleFast = "sheet.insertRule(\"#%s {background-color:rgba(%s,%s,%s,%s);}\", 0);"; //$NON-NLS-1$
+	
 	public static final String colorscriptRuleFast = "sheet.insertRule(\"#%s {color:rgba(%s,%s,%s,%s);}\", 0);"; //$NON-NLS-1$
+	
 	public static final String sizescriptRuleFast = "sheet.insertRule(\"#%s {font-size:%s;}\", 0);"; //$NON-NLS-1$
+	
 	public static final String stylescriptRuleFast = "sheet.insertRule(\"#%s {font-style:%s;}\", 0);"; //$NON-NLS-1$
+	
 	public static final String variantscriptRuleFast = "sheet.insertRule(\"#%s {font-variant:%s;}\", 0);"; //$NON-NLS-1$
+	
 	public static final String famillyscriptRuleFast = "sheet.insertRule(\"#%s {font-familly:%s;}\", 0);"; //$NON-NLS-1$
+	
 	public static final String weightscriptRuleFast = "sheet.insertRule(\"#%s {font-weight:%s;}\", 0);"; //$NON-NLS-1$
 	
 	public static final String highlightscriptRule = "sheet.insertRule(\"span[id=\\\"%s\\\"] {background-color:rgba(%s,%s,%s,%s); }\", 0);"; //$NON-NLS-1$
@@ -105,136 +140,142 @@
 	public static final String clearhighlightscript = "try { var elt = document.getElementById(\"%s\"); elt.style.backgroundColor=\"white\";elt.style.fontWeight=\"\";" + //$NON-NLS-1$
 			"} catch (e) { };"; //$NON-NLS-1$
 	
-	public String functions = 
-			""//"alert(\"loading functions\");" //$NON-NLS-1$
-			+"\nfunction getNodeText(node) {" //$NON-NLS-1$
-			+"\n	if (typeof node == 'string') return node;" //$NON-NLS-1$
-			+"\n	else if (typeof  node.innerText != 'undefined') return node.innerText;" //$NON-NLS-1$
-			+"\n	else if (typeof  node.InnerText != 'undefined') return node.InnerText;" //$NON-NLS-1$
-			+"\n	else if (typeof  node.textContent != 'undefined') return node.textContent;" //$NON-NLS-1$
-			+"\n	else return null;" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction txmGetParent(node) {" //$NON-NLS-1$
-			+"\n	if (typeof  node.parentNode != 'undefined') return node.parentNode;" //$NON-NLS-1$
-			+"\n	else return null;" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction txmGetChildren(node) {" //$NON-NLS-1$
-			+"\n	if (typeof node == 'string') return 'STRING HTML';" //$NON-NLS-1$
-			+"\n	else if (typeof  node.children != 'undefined') return node.children;" //$NON-NLS-1$
-			+"\n	else if (typeof  node.ChildNodes != 'undefined') return node.ChildNodes;" //$NON-NLS-1$
-			+"\n	else if (typeof  node.childNodes != 'undefined') return node.childNodes;" //$NON-NLS-1$
-			+"\n	else return null;" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction txmGetSelection() {" //$NON-NLS-1$
-			+"\n	if (typeof window.getSelection != 'undefined') {return window.getSelection();}" //$NON-NLS-1$
-			+"\n	else if (typeof document.selection != 'undefined') { return document.selection;}" //$NON-NLS-1$
-			+"\n	else return 'NO SELECTION';" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction txmGetRangeSize(selection) {" //$NON-NLS-1$
-			+"\n	if (typeof selection.rangeCount != 'undefined') {return selection.rangeCount;}" //$NON-NLS-1$
-			+"\n	else if (typeof selection.createRangeCollection != 'undefined') { return selection.createRangeCollection().length();} // IE5 has no multiple selection" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction txmGetRange(selection, i) {" //$NON-NLS-1$
-			+"\n	if (typeof selection.getRangeAt != 'undefined') {return selection.getRangeAt(i);}" //$NON-NLS-1$
-			+"\n	else if (typeof selection.createRangeCollection != 'undefined') {return selection.createRangeCollection().item(i);}" // IE > IE5  //$NON-NLS-1$
-			+"\n	else if (typeof selection.createRange != 'undefined') { return selection.createRange();} // IE5 has no multiple selection" //$NON-NLS-1$
-			+"\n	else return 'NO RANGE';" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction txmGetParentElementRange(range) {" //$NON-NLS-1$
-			+"\n	if (typeof range.parentElement != 'undefined') {return range.parentElement();}" //$NON-NLS-1$
-			+"\n	else if (typeof range.startContainer != 'undefined') { return range.startContainer.parentNode;}" //$NON-NLS-1$
-			+"\n	else return 'NO PARENT';" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction txmGetFragment(range) {" //$NON-NLS-1$
-			+"\n	if (typeof range.cloneContents != 'undefined') { return range.cloneContents();}" //$NON-NLS-1$
-			+"\n	else if (typeof range.htmlText != 'undefined') {var node = document.createElement('sel'); node.innerHTML = range.htmlText; 		return node;" //$NON-NLS-1$
-			+"\n	} else return 'NO FRAG';" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction txmGetTagName(node) {" //$NON-NLS-1$
-			+"\n	if (typeof node.tagName != 'undefined') {return node.tagName;}" //$NON-NLS-1$
-			+"\n	else if (typeof node.nodeName != 'undefined') { return node.nodeName;}" //$NON-NLS-1$
-			+"\n	else if (typeof node.name != 'undefined') { return node.name;}" //$NON-NLS-1$
-			+"\n	else return 'NO TAGNAME';" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction findSpans(children, all) {" //$NON-NLS-1$
-			+"\n    for (var i = 0 ; i < children.length ; i++) {" //$NON-NLS-1$
-			+"\n    	var node = children.item(i);" //$NON-NLS-1$
-			+"\n		if (node.nodeType == 1) {" //$NON-NLS-1$
-			+"\n    	var id = node.getAttribute('id');" //$NON-NLS-1$
-			+"\n       		if (node.tagName == 'SPAN' && id != null && id.indexOf('w_') == 0 && getNodeText(node).length > 0) {" //$NON-NLS-1$
-			+"\n            	if (id != null) all.push(id);" //$NON-NLS-1$
-			+"\n        	} else {" //$NON-NLS-1$
-			+"\n        		findSpans(txmGetChildren(node), all)" //$NON-NLS-1$
-			+"\n        	}" //$NON-NLS-1$
-			+"\n		}" //$NON-NLS-1$
-			+"\n	}" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction findIdsInString(str, all) {" //$NON-NLS-1$
-			+"\n    for (var i = 0 ; i < children.length ; i++) {" //$NON-NLS-1$
-			+"\n    	var node = children.item(i);" //$NON-NLS-1$
-			+"\n		if (node.nodeType == 1) {" //$NON-NLS-1$
-			+"\n    	var id = node.getAttribute('id');" //$NON-NLS-1$
-			+"\n       		if (node.tagName == 'SPAN' && id != null && id.indexOf('w_') == 0 && getNodeText(node).length > 0) {" //$NON-NLS-1$
-			+"\n            	if (id != null) all.push(id);" //$NON-NLS-1$
-			+"\n        	} else {" //$NON-NLS-1$
-			+"\n        		findSpans(txmGetChildren(node), all)" //$NON-NLS-1$
-			+"\n        	}" //$NON-NLS-1$
-			+"\n		}" //$NON-NLS-1$
-			+"\n	}" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\nfunction get_type(thing){if(thing===null)return \"[object Null]\";  return Object.prototype.toString.call(thing);}\n" //$NON-NLS-1$
-			+"\nfunction getDetailedObject(inputObject) { var detailedObject = {}; var properties; \n   do {        properties = Object.getOwnPropertyNames( inputObject );        for (var o in properties) {detailedObject[properties[o]] = inputObject[properties[o]];}} while ( inputObject = Object.getPrototypeOf(inputObject) );return detailedObject;}\n" //$NON-NLS-1$
-			+"\nvar sheet = null;" //$NON-NLS-1$
-			+"\ntry{" //$NON-NLS-1$
-			+"\n	var style = document.createElement(\"style\");" //$NON-NLS-1$
-			+"\n	try { style.appendChild(document.createTextNode(\"\")); } catch (e) {};"//webkit hack //$NON-NLS-1$
-			+"\n	document.body.appendChild(style);" //$NON-NLS-1$
-			+"\n	sheet = style.sheet;" //$NON-NLS-1$
-			+"\n} catch(e) {sheet='error'}" //$NON-NLS-1$
-			+"\ntry{" //$NON-NLS-1$
-			+"\n" // define scrollIntoViewIfNeeded if absent //$NON-NLS-1$
-			+"\nif (!Element.prototype.scrollIntoViewIfNeeded) {" //$NON-NLS-1$
-			+"\n	Element.prototype.scrollIntoViewIfNeeded = function (centerIfNeeded) {" //$NON-NLS-1$
-			+"\n		centerIfNeeded = arguments.length === 0 ? true : !!centerIfNeeded;" //$NON-NLS-1$
-			+"\n		var parent = this.parentNode," //$NON-NLS-1$
-			+"\n		parentComputedStyle = window.getComputedStyle(parent, null)," //$NON-NLS-1$
-			+"\n		parentBorderTopWidth = parseInt(parentComputedStyle.getPropertyValue('border-top-width'))," //$NON-NLS-1$
-			+"\n		parentBorderLeftWidth = parseInt(parentComputedStyle.getPropertyValue('border-left-width'))," //$NON-NLS-1$
-			+"\n		overTop = this.offsetTop - parent.offsetTop < parent.scrollTop," //$NON-NLS-1$
-			+"\n		overBottom = (this.offsetTop - parent.offsetTop + this.clientHeight - parentBorderTopWidth) > (parent.scrollTop + parent.clientHeight)," //$NON-NLS-1$
-			+"\n		overLeft = this.offsetLeft - parent.offsetLeft < parent.scrollLeft," //$NON-NLS-1$
-			+"\n		overRight = (this.offsetLeft - parent.offsetLeft + this.clientWidth - parentBorderLeftWidth) > (parent.scrollLeft + parent.clientWidth)," //$NON-NLS-1$
-			+"\n		alignWithTop = overTop && !overBottom;" //$NON-NLS-1$
-			+"\n		if ((overTop || overBottom) && centerIfNeeded) {" //$NON-NLS-1$
-			+"\n			parent.scrollTop = this.offsetTop - parent.offsetTop - parent.clientHeight / 2 - parentBorderTopWidth + this.clientHeight / 2;" //$NON-NLS-1$
-			+"\n		}" //$NON-NLS-1$
-			+"\n		if ((overLeft || overRight) && centerIfNeeded) {" //$NON-NLS-1$
-			+"\n			parent.scrollLeft = this.offsetLeft - parent.offsetLeft - parent.clientWidth / 2 - parentBorderLeftWidth + this.clientWidth / 2;" //$NON-NLS-1$
-			+"\n		}" //$NON-NLS-1$
-			+"\n		if ((overTop || overBottom || overLeft || overRight) && !centerIfNeeded) {" //$NON-NLS-1$
-			+"\n			this.scrollIntoView(alignWithTop);" //$NON-NLS-1$
-			+"\n		}" //$NON-NLS-1$
-			+"\n	};" //$NON-NLS-1$
-			+"\n}" //$NON-NLS-1$
-			+"\n} catch(e) {Element.prototype.scrollIntoViewIfNeeded = Element.prototype.scrollIntoView}"; //$NON-NLS-1$
+	public String functions = ""// "alert(\"loading functions\");" //$NON-NLS-1$
+			+ "\nfunction getNodeText(node) {" //$NON-NLS-1$
+			+ "\n	if (typeof node == 'string') return node;" //$NON-NLS-1$
+			+ "\n	else if (typeof  node.innerText != 'undefined') return node.innerText;" //$NON-NLS-1$
+			+ "\n	else if (typeof  node.InnerText != 'undefined') return node.InnerText;" //$NON-NLS-1$
+			+ "\n	else if (typeof  node.textContent != 'undefined') return node.textContent;" //$NON-NLS-1$
+			+ "\n	else return null;" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction txmGetParent(node) {" //$NON-NLS-1$
+			+ "\n	if (typeof  node.parentNode != 'undefined') return node.parentNode;" //$NON-NLS-1$
+			+ "\n	else return null;" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction txmGetChildren(node) {" //$NON-NLS-1$
+			+ "\n	if (typeof node == 'string') return 'STRING HTML';" //$NON-NLS-1$
+			+ "\n	else if (typeof  node.children != 'undefined') return node.children;" //$NON-NLS-1$
+			+ "\n	else if (typeof  node.ChildNodes != 'undefined') return node.ChildNodes;" //$NON-NLS-1$
+			+ "\n	else if (typeof  node.childNodes != 'undefined') return node.childNodes;" //$NON-NLS-1$
+			+ "\n	else return null;" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction txmGetSelection() {" //$NON-NLS-1$
+			+ "\n	if (typeof window.getSelection != 'undefined') {return window.getSelection();}" //$NON-NLS-1$
+			+ "\n	else if (typeof document.selection != 'undefined') { return document.selection;}" //$NON-NLS-1$
+			+ "\n	else return 'NO SELECTION';" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction txmGetRangeSize(selection) {" //$NON-NLS-1$
+			+ "\n	if (typeof selection.rangeCount != 'undefined') {return selection.rangeCount;}" //$NON-NLS-1$
+			+ "\n	else if (typeof selection.createRangeCollection != 'undefined') { return selection.createRangeCollection().length();} // IE5 has no multiple selection" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction txmGetRange(selection, i) {" //$NON-NLS-1$
+			+ "\n	if (typeof selection.getRangeAt != 'undefined') {return selection.getRangeAt(i);}" //$NON-NLS-1$
+			+ "\n	else if (typeof selection.createRangeCollection != 'undefined') {return selection.createRangeCollection().item(i);}" // IE > IE5 //$NON-NLS-1$
+			+ "\n	else if (typeof selection.createRange != 'undefined') { return selection.createRange();} // IE5 has no multiple selection" //$NON-NLS-1$
+			+ "\n	else return 'NO RANGE';" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction txmGetParentElementRange(range) {" //$NON-NLS-1$
+			+ "\n	if (typeof range.parentElement != 'undefined') {return range.parentElement();}" //$NON-NLS-1$
+			+ "\n	else if (typeof range.startContainer != 'undefined') { return range.startContainer.parentNode;}" //$NON-NLS-1$
+			+ "\n	else return 'NO PARENT';" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction txmGetFragment(range) {" //$NON-NLS-1$
+			+ "\n	if (typeof range.cloneContents != 'undefined') { return range.cloneContents();}" //$NON-NLS-1$
+			+ "\n	else if (typeof range.htmlText != 'undefined') {var node = document.createElement('sel'); node.innerHTML = range.htmlText; 		return node;" //$NON-NLS-1$
+			+ "\n	} else return 'NO FRAG';" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction txmGetTagName(node) {" //$NON-NLS-1$
+			+ "\n	if (typeof node.tagName != 'undefined') {return node.tagName;}" //$NON-NLS-1$
+			+ "\n	else if (typeof node.nodeName != 'undefined') { return node.nodeName;}" //$NON-NLS-1$
+			+ "\n	else if (typeof node.name != 'undefined') { return node.name;}" //$NON-NLS-1$
+			+ "\n	else return 'NO TAGNAME';" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction findSpans(children, all) {" //$NON-NLS-1$
+			+ "\n    for (var i = 0 ; i < children.length ; i++) {" //$NON-NLS-1$
+			+ "\n    	var node = children.item(i);" //$NON-NLS-1$
+			+ "\n		if (node.nodeType == 1) {" //$NON-NLS-1$
+			+ "\n    	var id = node.getAttribute('id');" //$NON-NLS-1$
+			+ "\n       		if (node.tagName == 'SPAN' && id != null && id.indexOf('w_') == 0 && getNodeText(node).length > 0) {" //$NON-NLS-1$
+			+ "\n            	if (id != null) all.push(id);" //$NON-NLS-1$
+			+ "\n        	} else {" //$NON-NLS-1$
+			+ "\n        		findSpans(txmGetChildren(node), all)" //$NON-NLS-1$
+			+ "\n        	}" //$NON-NLS-1$
+			+ "\n		}" //$NON-NLS-1$
+			+ "\n	}" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction findIdsInString(str, all) {" //$NON-NLS-1$
+			+ "\n    for (var i = 0 ; i < children.length ; i++) {" //$NON-NLS-1$
+			+ "\n    	var node = children.item(i);" //$NON-NLS-1$
+			+ "\n		if (node.nodeType == 1) {" //$NON-NLS-1$
+			+ "\n    	var id = node.getAttribute('id');" //$NON-NLS-1$
+			+ "\n       		if (node.tagName == 'SPAN' && id != null && id.indexOf('w_') == 0 && getNodeText(node).length > 0) {" //$NON-NLS-1$
+			+ "\n            	if (id != null) all.push(id);" //$NON-NLS-1$
+			+ "\n        	} else {" //$NON-NLS-1$
+			+ "\n        		findSpans(txmGetChildren(node), all)" //$NON-NLS-1$
+			+ "\n        	}" //$NON-NLS-1$
+			+ "\n		}" //$NON-NLS-1$
+			+ "\n	}" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\nfunction get_type(thing){if(thing===null)return \"[object Null]\";  return Object.prototype.toString.call(thing);}\n" //$NON-NLS-1$
+			+ "\nfunction getDetailedObject(inputObject) { var detailedObject = {}; var properties; \n   do {        properties = Object.getOwnPropertyNames( inputObject );        for (var o in properties) {detailedObject[properties[o]] = inputObject[properties[o]];}} while ( inputObject = Object.getPrototypeOf(inputObject) );return detailedObject;}\n" //$NON-NLS-1$
+			+ "\nvar sheet = null;" //$NON-NLS-1$
+			+ "\ntry{" //$NON-NLS-1$
+			+ "\n	var style = document.createElement(\"style\");" //$NON-NLS-1$
+			+ "\n	try { style.appendChild(document.createTextNode(\"\")); } catch (e) {};"// webkit hack //$NON-NLS-1$
+			+ "\n	document.body.appendChild(style);" //$NON-NLS-1$
+			+ "\n	sheet = style.sheet;" //$NON-NLS-1$
+			+ "\n} catch(e) {sheet='error'}" //$NON-NLS-1$
+			+ "\ntry{" //$NON-NLS-1$
+			+ "\n" // define scrollIntoViewIfNeeded if absent //$NON-NLS-1$
+			+ "\nif (!Element.prototype.scrollIntoViewIfNeeded) {" //$NON-NLS-1$
+			+ "\n	Element.prototype.scrollIntoViewIfNeeded = function (centerIfNeeded) {" //$NON-NLS-1$
+			+ "\n		centerIfNeeded = arguments.length === 0 ? true : !!centerIfNeeded;" //$NON-NLS-1$
+			+ "\n		var parent = this.parentNode," //$NON-NLS-1$
+			+ "\n		parentComputedStyle = window.getComputedStyle(parent, null)," //$NON-NLS-1$
+			+ "\n		parentBorderTopWidth = parseInt(parentComputedStyle.getPropertyValue('border-top-width'))," //$NON-NLS-1$
+			+ "\n		parentBorderLeftWidth = parseInt(parentComputedStyle.getPropertyValue('border-left-width'))," //$NON-NLS-1$
+			+ "\n		overTop = this.offsetTop - parent.offsetTop < parent.scrollTop," //$NON-NLS-1$
+			+ "\n		overBottom = (this.offsetTop - parent.offsetTop + this.clientHeight - parentBorderTopWidth) > (parent.scrollTop + parent.clientHeight)," //$NON-NLS-1$
+			+ "\n		overLeft = this.offsetLeft - parent.offsetLeft < parent.scrollLeft," //$NON-NLS-1$
+			+ "\n		overRight = (this.offsetLeft - parent.offsetLeft + this.clientWidth - parentBorderLeftWidth) > (parent.scrollLeft + parent.clientWidth)," //$NON-NLS-1$
+			+ "\n		alignWithTop = overTop && !overBottom;" //$NON-NLS-1$
+			+ "\n		if ((overTop || overBottom) && centerIfNeeded) {" //$NON-NLS-1$
+			+ "\n			parent.scrollTop = this.offsetTop - parent.offsetTop - parent.clientHeight / 2 - parentBorderTopWidth + this.clientHeight / 2;" //$NON-NLS-1$
+			+ "\n		}" //$NON-NLS-1$
+			+ "\n		if ((overLeft || overRight) && centerIfNeeded) {" //$NON-NLS-1$
+			+ "\n			parent.scrollLeft = this.offsetLeft - parent.offsetLeft - parent.clientWidth / 2 - parentBorderLeftWidth + this.clientWidth / 2;" //$NON-NLS-1$
+			+ "\n		}" //$NON-NLS-1$
+			+ "\n		if ((overTop || overBottom || overLeft || overRight) && !centerIfNeeded) {" //$NON-NLS-1$
+			+ "\n			this.scrollIntoView(alignWithTop);" //$NON-NLS-1$
+			+ "\n		}" //$NON-NLS-1$
+			+ "\n	};" //$NON-NLS-1$
+			+ "\n}" //$NON-NLS-1$
+			+ "\n} catch(e) {Element.prototype.scrollIntoViewIfNeeded = Element.prototype.scrollIntoView}"; //$NON-NLS-1$
 	
 	protected boolean fastWordHighLight = SynopticEditionPreferences.getInstance().getBoolean(SynopticEditionPreferences.FAST_HIGHLIGHT);
+	
 	private ArrayList<ProgressListener> beforeHighlighListeners;
+	
 	public ArrayList<ProgressListener> getBeforeHighlighListeners() {
 		return beforeHighlighListeners;
 	}
+	
 	private ArrayList<ProgressListener> afterHighlighListeners;
+	
 	public ArrayList<ProgressListener> getAfterHighlighListeners() {
 		return beforeHighlighListeners;
 	}
+	
 	public Object evaluate(String code) {
 		if (Log.getLevel().intValue() <= Level.FINEST.intValue()) System.out.println(code);
 		return getBrowser().evaluate(code);
 	}
+	
 	public boolean execute(String code) {
 		if (Log.getLevel().intValue() <= Level.FINEST.intValue()) System.out.println(code);
 		return getBrowser().execute(code);
 	}
+	
 	public EditionPanel(SynopticEditionEditor synopticEditionEditor, Composite parent, int style, Edition edition) {
 		super(parent, style);
 		this.synopticEditionEditor = synopticEditionEditor;
@@ -246,53 +287,58 @@
 			Bundle bundle = Platform.getBundle("org.txm.edition.rcp"); //$NON-NLS-1$
 			URL fileURL = bundle.getEntry("res/js/functions.js"); //$NON-NLS-1$
 			URL r = FileLocator.resolve(fileURL);
-			Log.fine("Load JS functions from: "+r);
+			Log.fine("Load JS functions from: " + r);
 			functions = IOUtils.getText(r, "UTF-8"); //$NON-NLS-1$
 			
-		} catch (Exception e) {
+		}
+		catch (Exception e) {
 			Log.severe(EditionUIMessages.bind(EditionUIMessages.error_while_reading, functionsFile, e.getLocalizedMessage()));
 			Log.printStackTrace(e);
 		}
 		
-		beforeHighlighListeners = new ArrayList<ProgressListener>();
-		afterHighlighListeners = new ArrayList<ProgressListener>();
+		beforeHighlighListeners = new ArrayList<>();
+		afterHighlighListeners = new ArrayList<>();
 		
 		progresslistener = new ProgressListener() {
 			
 			@Override
-			public void changed(ProgressEvent event) { }
+			public void changed(ProgressEvent event) {}
 			
 			@Override
 			public void completed(ProgressEvent event) {
 				
-				//System.out.println("EditionPanel "+currentEdition.getName()+" reload "+getCurrentPage().getName());
+				// System.out.println("EditionPanel "+currentEdition.getName()+" reload "+getCurrentPage().getName());
 				Object rez = evaluate("return typeof sheet;"); //$NON-NLS-1$
 				if ("undefined".equals(rez)) { //$NON-NLS-1$
 					if (!execute(functions)) { // build the sheet if not present in the HTML DOM
-						Log.fine("JS execution (init) error with="+functions); //$NON-NLS-1$
-					} else {
+						Log.fine("JS execution (init) error with=" + functions); //$NON-NLS-1$
+					}
+					else {
 						
 					}
 				}
 				
 				// do something before the highlight is done
-				for (ProgressListener pl : beforeHighlighListeners) { pl.completed(event);}
+				for (ProgressListener pl : beforeHighlighListeners) {
+					pl.completed(event);
+				}
 				
 				
-				//System.out.println("highlight: "+highlightedColorPerWordIDS);
+				// System.out.println("highlight: "+highlightedColorPerWordIDS);
 				StringBuilder buffer = new StringBuilder();
-				//buffer.append("alert(\"\"+sheet);\n");
+				// buffer.append("alert(\"\"+sheet);\n");
 				if (!fastWordHighLight) {
-					//					for (String wordid : highlightedColorPerWordIDS.keySet()) {
-					//						buffer.append(String.format(clearhighlightscript, wordid)+"\n");
-					//					}
-				} else {
+					// for (String wordid : highlightedColorPerWordIDS.keySet()) {
+					// buffer.append(String.format(clearhighlightscript, wordid)+"\n");
+					// }
+				}
+				else {
 					buffer.append("try { while(sheet.cssRules.length > 0) sheet.deleteRule(0); } catch (e) {};\n"); // empty style //$NON-NLS-1$
 				}
 				
 				if (buffer.length() > 0) {
 					if (!execute(buffer.toString())) {
-						Log.fine("JS execution error (delete cssRules) with="+buffer);
+						Log.fine("JS execution error (delete cssRules) with=" + buffer);
 					}
 				}
 				
@@ -304,8 +350,8 @@
 				String lastWord = "w_999999999"; //$NON-NLS-1$
 				while (nextPage != null && currentPage != nextPage) {
 					lastWord = nextPage.getWordId();
-					if (!("w_0".equals(lastWord))) { // this is a word id 
-						break; // ok 
+					if (!("w_0".equals(lastWord))) { // this is a word id
+						break; // ok
 					}
 					Page p = currentEdition.getNextPage(nextPage);
 					if (p == nextPage) { // end of pages
@@ -314,20 +360,20 @@
 					}
 					nextPage = p;
 				}
-				//System.out.println("firstWord="+firstWord+" lastWord="+lastWord);
-				//int n = 0;
-				//long start = System.currentTimeMillis();
+				// System.out.println("firstWord="+firstWord+" lastWord="+lastWord);
+				// int n = 0;
+				// long start = System.currentTimeMillis();
 				
 				for (String wordid : highlightedColorPerWordIDS.keySet()) {
-					//Log.finest("words to highlight: "+highlightedColorPerWordIDS);
+					// Log.finest("words to highlight: "+highlightedColorPerWordIDS);
 					if (highlightedColorPerWordIDS.get(wordid).size() == 0) continue; // error
 					
-					//if (!slowWordHighLight) { //TODO: this code must be replaced with word position instead of word id comparaison
+					// if (!slowWordHighLight) { //TODO: this code must be replaced with word position instead of word id comparaison
 					if (Edition.isFirstGTthanSecond(wordid, firstWord) < 0) continue; // skip the word to highlight
 					if (Edition.isFirstGTthanSecond(lastWord, wordid) < 0) continue; // skip the word to highlight
-					//}
-					//n++;
-					RGBA composite = new RGBA(0,0,0,0f);
+					// }
+					// n++;
+					RGBA composite = new RGBA(0, 0, 0, 0f);
 					int size = highlightedColorPerWordIDS.get(wordid).size();
 					
 					for (RGBA color : highlightedColorPerWordIDS.get(wordid)) {
@@ -343,54 +389,55 @@
 					
 					String s = null;
 					if (!fastWordHighLight) {
-						//s = String.format(highlightscriptRule, wordid, composite.r, composite.g, composite.b, composite.a);
-						s = "try { document.getElementById(\"" + wordid + "\").style.backgroundColor=\"rgba("+composite.r+","+composite.g+","+composite.b+","+composite.a+")\";" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
-								+ 
-								//								"elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
-								//								"elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
-								//								"elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
-								//								"elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
+						// s = String.format(highlightscriptRule, wordid, composite.r, composite.g, composite.b, composite.a);
+						s = "try { document.getElementById(\"" + wordid + "\").style.backgroundColor=\"rgba(" + composite.r + "," + composite.g + "," + composite.b + "," + composite.a + ")\";" //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
+								+
+						// "elt.style.paddingLeft=\"3px\";" + //$NON-NLS-1$
+						// "elt.style.paddingRight=\"3px\";" + //$NON-NLS-1$
+						// "elt.style.paddingTop=\"1px\";" + //$NON-NLS-1$
+						// "elt.style.paddingBottom=\"1px\";" + //$NON-NLS-1$
 								"} catch (e) { };"; //$NON-NLS-1$
-					} else {
-						//TODO: replace this line with the next one for TXM 0.7.9
+					}
+					else {
+						// TODO: replace this line with the next one for TXM 0.7.9
 						s = String.format(highlightscriptRuleFast, wordid.replace(" ", "\\ "), composite.r, composite.g, composite.b, composite.a); //$NON-NLS-1$ //$NON-NLS-2$
-						//						s = String.format(highlightscriptRuleFast, wordid, composite.r, composite.g, composite.b, composite.a);
+						// s = String.format(highlightscriptRuleFast, wordid, composite.r, composite.g, composite.b, composite.a);
 					}
 					
-					buffer.append(s+"\n"); //$NON-NLS-1$
+					buffer.append(s + "\n"); //$NON-NLS-1$
 				}
 				
 				if (buffer.length() > 0) {
 					if (!execute(buffer.toString())) {
-						Log.fine("JS execution (highlight) error with="+buffer);
+						Log.fine("JS execution (highlight) error with=" + buffer);
 					}
 				}
 				
 				
 				buffer = new StringBuilder();
 				
-				//				for (String wordidslist : highlightedColorSpans.keySet()) {
-				//					RGBA composite = new RGBA(0,0,0,0f);
-				//					int size = highlightedColorSpans.get(wordidslist).size();
-				//					
-				//					for (RGBA color : highlightedColorSpans.get(wordidslist)) {
-				//						composite.r += color.r;
-				//						composite.g += color.g;
-				//						composite.b += color.b;
-				//						composite.a += color.a;
-				//					}
-				//					
-				//					composite.r /= size;
-				//					composite.g /= size;
-				//					composite.b /= size;
-				//					
-				//					String cmd = "var l = "+wordidslist+";\n";
-				//					cmd += "wrap(l, \""+wordidslist+"\";\n";
-				//					buffer.append(cmd+"\n");
-				//				}
+				// for (String wordidslist : highlightedColorSpans.keySet()) {
+				// RGBA composite = new RGBA(0,0,0,0f);
+				// int size = highlightedColorSpans.get(wordidslist).size();
+				//
+				// for (RGBA color : highlightedColorSpans.get(wordidslist)) {
+				// composite.r += color.r;
+				// composite.g += color.g;
+				// composite.b += color.b;
+				// composite.a += color.a;
+				// }
+				//
+				// composite.r /= size;
+				// composite.g /= size;
+				// composite.b /= size;
+				//
+				// String cmd = "var l = "+wordidslist+";\n";
+				// cmd += "wrap(l, \""+wordidslist+"\";\n";
+				// buffer.append(cmd+"\n");
+				// }
 				
 				for (String wordid : fontColorPerWordIDS.keySet()) {
-					RGBA composite = new RGBA(0,0,0,0f);
+					RGBA composite = new RGBA(0, 0, 0, 0f);
 					int size = fontColorPerWordIDS.get(wordid).size();
 					
 					for (RGBA color : fontColorPerWordIDS.get(wordid)) {
